Crypto++ 8.2 Free C++ class library of cryptographic schemes

Public Types | Public Member Functions | List of all members
DL_PrivateKeyImpl< GP > Class Template Reference

Discrete Log (DL) private key base implementation. More...

Inheritance diagram for DL_PrivateKeyImpl< GP >:

## Public Types
typedef GP::Element | Element
Public Types inherited from DL_PrivateKey< GP::Element >
typedef GP::Element | Element
Public Types inherited from DL_KeyImpl< PKCS8PrivateKey, GP >
typedef GP | GroupParameters

## Public Member Functions
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object. More...
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &params)
| Generate a random key or crypto parameters. More...
bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
void | Precompute (unsigned int precomputationStorage=16)
| Perform precomputation. More...
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
const DL_GroupParameters< Element > & | GetAbstractGroupParameters () const
| Retrieves abstract group parameters. More...
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()
| Retrieves abstract group parameters. More...
const Integer & | GetPrivateExponent () const
| Retrieves the private exponent. More...
void | SetPrivateExponent (const Integer &x)
| Sets the private exponent. More...
void | BERDecodePrivateKey (BufferedTransformation &bt, bool, size_t)
| Decode privateKey part of privateKeyInfo. More...
void | DEREncodePrivateKey (BufferedTransformation &bt) const
| Encode privateKey part of privateKeyInfo. More...
Public Member Functions inherited from DL_PrivateKey< GP::Element >
void | MakePublicKey (DL_PublicKey< GP::Element > &pub) const
| Initializes a public key from this key. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Initialize or reinitialize this key. More...
Public Member Functions inherited from DL_KeyImpl< PKCS8PrivateKey, GP >
OID | GetAlgorithmID () const
bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
const GP & | GetGroupParameters () const
GP & | AccessGroupParameters ()
Public Member Functions inherited from PKCS8PrivateKey
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation. More...
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
virtual void | BERDecodeOptionalAttributes (BufferedTransformation &bt)
| Decode optional attributes. More...
virtual void | DEREncodeOptionalAttributes (BufferedTransformation &bt) const
| Encode optional attributes. More...
Public Member Functions inherited from ASN1CryptoMaterial< PrivateKey >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object. More...
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object. More...
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
Public Member Functions inherited from GeneratableCryptoMaterial
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters. More...
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64. More...
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...

## Additional Inherited Members
Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void CRYPTOPP_API | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Detailed Description

### template<class GP>
class DL_PrivateKeyImpl< GP >

Discrete Log (DL) private key base implementation.

Template Parameters

  GP | GroupParameters class

Definition at line 1238 of file pubkey.h.

## Member Function Documentation

## ◆ Validate()

template<class GP>

bool DL_PrivateKeyImpl< GP >::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const
| inline virtual

Check this object for errors.

Parameters

  rng | a RandomNumberGenerator for objects which use randomized testing
  level | the level of thoroughness

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 does not require a RandomNumberGenerator. A NullRNG() can be used for level 0. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

See also
  ThrowIfInvalid()

Implements CryptoMaterial.

Definition at line 1246 of file pubkey.h.

## ◆ GetVoidValue()

template<class GP>

bool DL_PrivateKeyImpl< GP >::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue
| ) |  | const
| inline virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Implements NameValuePairs.

Definition at line 1266 of file pubkey.h.

## ◆ AssignFrom()

template<class GP>

void DL_PrivateKeyImpl< GP >::AssignFrom | ( | const NameValuePairs & | source | ) |
| inline virtual

Assign values to this object.

This function can be used to create a public key from a private key.

Implements CryptoMaterial.

Definition at line 1271 of file pubkey.h.

## ◆ GenerateRandom()

template<class GP>

void DL_PrivateKeyImpl< GP >::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | params
| ) |  |
| inline virtual

Generate a random key or crypto parameters.

Parameters

  rng | a RandomNumberGenerator to produce keying material
  params | additional initialization parameters

Exceptions

  KeyingErr | if a key can't be generated or algorithm parameters are invalid

If a derived class does not override GenerateRandom(), then the base class throws NotImplemented.

Reimplemented from GeneratableCryptoMaterial.

Definition at line 1276 of file pubkey.h.

## ◆ SupportsPrecomputation()

template<class GP>

bool DL_PrivateKeyImpl< GP >::SupportsPrecomputation | ( |  | ) | const
| inline virtual

Determines whether the object supports precomputation.

Returns
  true if the object supports precomputation, false otherwise

See also
  Precompute()

Reimplemented from CryptoMaterial.

Definition at line 1284 of file pubkey.h.

## ◆ Precompute()

template<class GP>

void DL_PrivateKeyImpl< GP >::Precompute | ( | unsigned int | precomputationStorage = `16` | ) |
| inline virtual

Perform precomputation.

Parameters

  precomputationStorage | the suggested number of objects for the precompute table

Exceptions

  NotImplemented |

The exact semantics of Precompute() varies, but it typically means calculate a table of n objects that can be used later to speed up computation.

If a derived class does not override Precompute(), then the base class throws NotImplemented.

See also
  SupportsPrecomputation(), LoadPrecomputation(), SavePrecomputation()

Reimplemented from CryptoMaterial.

Definition at line 1286 of file pubkey.h.

## ◆ LoadPrecomputation()

template<class GP>

void DL_PrivateKeyImpl< GP >::LoadPrecomputation | ( | BufferedTransformation & | storedPrecomputation | ) |
| inline virtual

Retrieve previously saved precomputation.

Parameters

  storedPrecomputation | BufferedTransformation with the saved precomputation

Exceptions

  NotImplemented |

See also
  SupportsPrecomputation(), Precompute()

Reimplemented from CryptoMaterial.

Definition at line 1289 of file pubkey.h.

## ◆ SavePrecomputation()

template<class GP>

void DL_PrivateKeyImpl< GP >::SavePrecomputation | ( | BufferedTransformation & | storedPrecomputation | ) | const
| inline virtual

Save precomputation for later use.

Parameters

  storedPrecomputation | BufferedTransformation to write the precomputation

Exceptions

  NotImplemented |

See also
  SupportsPrecomputation(), Precompute()

Reimplemented from CryptoMaterial.

Definition at line 1292 of file pubkey.h.

## ◆ GetAbstractGroupParameters()

template<class GP>

const DL_GroupParameters<Element>& DL_PrivateKeyImpl< GP >::GetAbstractGroupParameters | ( |  | ) | const
| inline virtual

Retrieves abstract group parameters.

Returns
  a const reference to the group parameters

Implements DL_Key< GP::Element >.

Definition at line 1296 of file pubkey.h.

## ◆ AccessAbstractGroupParameters()

template<class GP>

DL_GroupParameters<Element>& DL_PrivateKeyImpl< GP >::AccessAbstractGroupParameters | ( |  | ) |
| inline virtual

Retrieves abstract group parameters.

Returns
  a non-const reference to the group parameters

Implements DL_Key< GP::Element >.

Definition at line 1297 of file pubkey.h.

## ◆ GetPrivateExponent()

template<class GP>

const Integer& DL_PrivateKeyImpl< GP >::GetPrivateExponent | ( |  | ) | const
| inline virtual

Retrieves the private exponent.

Returns
  the private exponent

Must be overridden in derived classes.

Implements DL_PrivateKey< GP::Element >.

Definition at line 1300 of file pubkey.h.

## ◆ SetPrivateExponent()

template<class GP>

void DL_PrivateKeyImpl< GP >::SetPrivateExponent | ( | const Integer & | x | ) |
| inline virtual

Sets the private exponent.

Parameters

  x | the private exponent

Must be overridden in derived classes.

Implements DL_PrivateKey< GP::Element >.

Definition at line 1301 of file pubkey.h.

## ◆ BERDecodePrivateKey()

template<class GP>

void DL_PrivateKeyImpl< GP >::BERDecodePrivateKey | ( | BufferedTransformation & | bt,
|  | bool | parametersPresent,
|  | size_t | size
| ) |  |
| inline virtual

Decode privateKey part of privateKeyInfo.

Parameters

  bt | BufferedTransformation object
  parametersPresent | flag indicating if algorithm parameters are present
  size | number of octets to read for the parameters, in bytes

BERDecodePrivateKey() the decodes privateKey part of privateKeyInfo, without the OCTET STRING header.

When `parametersPresent = true` then BERDecodePrivateKey() calls BERDecodeAlgorithmParameters() to parse algorithm parameters.

See also
  BERDecodeAlgorithmParameters

Implements PKCS8PrivateKey.

Definition at line 1304 of file pubkey.h.

## ◆ DEREncodePrivateKey()

template<class GP>

void DL_PrivateKeyImpl< GP >::DEREncodePrivateKey | ( | BufferedTransformation & | bt | ) | const
| inline virtual

Encode privateKey part of privateKeyInfo.

Parameters

  bt | BufferedTransformation object

DEREncodePrivateKey() encodes the privateKey part of privateKeyInfo, without the OCTET STRING header.

See also
  DEREncodeAlgorithmParameters

Implements PKCS8PrivateKey.

Definition at line 1306 of file pubkey.h.

The documentation for this class was generated from the following file:

- pubkey.h